<ng-container *ngIf="chat$ | async as chat">
  <main>
    <mat-card
      class="message"
      *ngFor="let msg of chat.messages; trackBy: trackByCreated; let last = last"
      [scrollIntoView]="last"
    >
      <mat-card-header>
        <div mat-card-avatar class="message__avatar">
          <img [src]="msg.user?.photoURL" />
        </div>
        <mat-card-title>{{ msg.user?.displayName }}</mat-card-title>
        <mat-card-subtitle>{{ msg.createdAt | date: 'medium' }}</mat-card-subtitle>
      </mat-card-header>
      <mat-card-content>
        <p>{{ msg.content }}</p>
      </mat-card-content>
    </mat-card>
  </main>

  <form
    [formGroup]="chatForm"
    #formDirective="ngForm"
    (submit)="submit(chat.id, formDirective)"
    class="form"
  >
    <mat-form-field>
      <input
        matInput
        placeholder="Message"
        name="message"
        [formControl]="messageControl"
        (keydown.enter)="submit(chat.id, formDirective)"
      />
      <mat-error *ngIf="messageControl.hasError('required')">
        Message is <strong>required</strong>
      </mat-error>
    </mat-form-field>
    <button mat-raised-button color="primary" [disabled]="!messageControl.valid">Send</button>
  </form>
</ng-container>
